#include <stdio.h>
#include <stdlib.h>
//#include <string>
#include <iostream>
#include <fstream>
using namespace std;

#include "MyClassIO.h"

#include "MyClassA.h"

//______________________________________________________________________________
MyClassA::MyClassA()
{
   cout << "---MyClassA::MyClassA()---------" << endl;
}

//______________________________________________________________________________
MyClassA::~MyClassA()
{
   cout << "---MyClassA::~MyClassA()---------" << endl;
}

//______________________________________________________________________________
int MyClassA::TestMultiply(int n, int m)
{
   cout << "------MyClassA::TestMultiply------" << endl;

   printf("printf: n * m = %d\n", n*m);
   cout << "cout:   " << n << " * " << m << " = " << n*m << endl;
   return (n * m);
}

//______________________________________________________________________________
void MyClassA::TestC(const char *name)
{
   cout << "------MyClassA::TestC------" << endl;

   const char *str = "char_string";
   printf("str = %s\n", str);

//   fString = name;
   printf("MyClassA: fString = %s\n", name);
}

//______________________________________________________________________________
void MyClassA::TestCpp(const char *name)
{
   cout << "------MyClassA::TestCpp------" << endl;

   const char *str = "char_string";
   cout << "  str = " << str << endl;

//   fString = name;
   cout << "  MyClassA: fString = " << name << endl;
}

//______________________________________________________________________________
void MyClassA::ReadFileC(const char *infile)
{
   cout << "------MyClassA::ReadFileC------" << endl;

   MyClassIO *classIO = new MyClassIO();

   classIO->ReadFileC(infile);

   delete classIO;
}

//______________________________________________________________________________
void MyClassA::ReadFileCpp(const char *infile)
{
   cout << "------MyClassA::ReadFileCCpp------" << endl;

   MyClassIO *classIO = new MyClassIO();

   classIO->ReadFileCpp(infile);

   delete classIO;
}

//______________________________________________________________________________
void MyClassA::WriteFileC(const char *outfile)
{
   cout << "------MyClassA::WriteFileC------" << endl;

   MyClassIO *classIO = new MyClassIO();

   classIO->WriteFileC(outfile);

   delete classIO;
}

//______________________________________________________________________________
void MyClassA::WriteFileCpp(const char *outfile)
{
   cout << "------MyClassA::WriteFileCpp------" << endl;

   MyClassIO *classIO = new MyClassIO();

   classIO->WriteFileCpp(outfile);

   delete classIO;
}

//______________________________________________________________________________
void MyClassA::ReadInFile(const char *infile)
{
   cout << "------MyClassA::ReadInFile------" << endl;

   MyClassIO *classIO = new MyClassIO();

   ifstream input;
   input.open(infile, ios::in);
   if (!input.good()) {
      cerr << "Error: File does not exist: " << infile << endl;
      input.close();
      return;
   }//if

   classIO->ReadIFileStream(input);

   input.close();

   delete classIO;
}

//______________________________________________________________________________
void MyClassA::WriteOutFile(const char *outfile)
{
   cout << "------MyClassA::WriteOutFile------" << endl;

   MyClassIO *classIO = new MyClassIO();

   ofstream output;
   output.open(outfile, ios::out);

   classIO->WriteOFileStream(output);

   output.close();

   delete classIO;
}

